import { GenerateTypescriptOptions } from './types';
import { IntrospectionQuery } from 'graphql';
export declare class TypeScriptGenerator {
    protected options: GenerateTypescriptOptions;
    constructor(options: GenerateTypescriptOptions);
    generate(introspectResult: IntrospectionQuery): Promise<string[]>;
    private generateCustomScalarType(scalarType);
    private isStringEnumSupported();
    private generateEnumType(enumType);
    private generateObjectType(objectType, allGQLTypes);
    private generateUnionType(unionType);
    /**
     * Create a union type e.g: type Color = 'Red' | 'Green' | 'Blue' | ...
     * Also, if the type is too long to fit in one line, split them info multiple lines
     * => type Color = 'Red'
     *      | 'Green'
     *      | 'Blue'
     *      | ...
     */
    private createUnionType(typeName, possibleTypes);
}
