import { GenerateTypescriptOptions } from './types';
import { IntrospectionQuery } from 'graphql/utilities/introspectionQuery';
export interface GenerateResolversResult {
    importHeader: string[];
    body: string[];
}
export declare class TSResolverGenerator {
    protected options: GenerateTypescriptOptions;
    protected importHeader: string[];
    protected resolverInterfaces: string[];
    protected resolverObject: string[];
    protected contextType: string;
    constructor(options: GenerateTypescriptOptions);
    generate(introspectionResult: IntrospectionQuery): Promise<GenerateResolversResult>;
    private generateCustomScalarResolver(scalarType);
    private generateTypeResolver(type);
    private toResultType(type);
    private generateObjectResolver(objectType);
}
