"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var TSResolverGenerator = /** @class */ (function () {
    function TSResolverGenerator(options) {
        this.options = options;
        this.importHeader = [];
        this.resolverInterfaces = [];
        this.resolverObject = [];
        if (options.resolver) {
            this.contextType = options.resolver.contextType;
            if (options.resolver.importContext) {
                this.importHeader.push(options.resolver.importContext);
            }
        }
        else {
            this.contextType = 'any';
        }
    }
    TSResolverGenerator.prototype.generate = function (introspectionResult) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var gqlTypes, hasCustomScalar;
            return __generator(this, function (_a) {
                gqlTypes = introspectionResult.__schema.types.filter(function (type) { return !utils_1.isBuiltinType(type); });
                hasCustomScalar = !!gqlTypes.find(function (type) { return type.kind === 'SCALAR'; });
                if (hasCustomScalar) {
                    this.importHeader.push("import { GraphQLResolveInfo, GraphQLScalarType } from 'graphql';");
                }
                else {
                    this.importHeader.push("import { GraphQLResolveInfo } from 'graphql';");
                }
                this.resolverObject = [
                    '/**',
                    ' * This interface define the shape of your resolver',
                    ' * Note that this type is designed to be compatible with graphql-tools resolvers',
                    ' * However, you can still use other generated interfaces to make your resolver type-safed',
                    ' */',
                    "export interface " + this.options.typePrefix + "Resolver {"
                ];
                gqlTypes.map(function (type) {
                    switch (type.kind) {
                        case 'SCALAR': {
                            _this.generateCustomScalarResolver(type);
                            break;
                        }
                        case 'OBJECT': {
                            _this.generateObjectResolver(type);
                            break;
                        }
                        case 'INTERFACE':
                        case 'UNION': {
                            _this.generateTypeResolver(type);
                            break;
                        }
                        case 'INPUT_OBJECT':
                        default: {
                            break;
                        }
                    }
                });
                this.resolverObject.push('}');
                return [2 /*return*/, {
                        importHeader: this.importHeader,
                        body: this.resolverObject.concat(this.resolverInterfaces)
                    }];
            });
        });
    };
    TSResolverGenerator.prototype.generateCustomScalarResolver = function (scalarType) {
        this.resolverObject.push(scalarType.name + "?: GraphQLScalarType;");
    };
    TSResolverGenerator.prototype.generateTypeResolver = function (type) {
        var possbileTypes = type.possibleTypes.map(function (pt) { return "'" + pt.name + "'"; });
        var interfaceName = "" + this.options.typePrefix + type.name + "TypeResolver";
        (_a = this.resolverInterfaces).push.apply(_a, [
            "export interface " + interfaceName + "<TParent = any> {",
            "(parent: TParent, context: " + this.contextType + ", info: GraphQLResolveInfo): " + possbileTypes.join(' | ') + ";",
            '}'
        ]);
        (_b = this.resolverObject).push.apply(_b, [
            type.name + "?: {",
            "__resolveType: " + interfaceName,
            '};',
            ''
        ]);
        var _a, _b;
    };
    TSResolverGenerator.prototype.toResultType = function (type) {
        if (type) {
            var kind = type.kind, name = type.name, ofType = type.ofType;
            if (kind === 'LIST') {
                return "Array<" + this.toResultType(ofType) + ">";
            }
            else if (ofType) {
                return this.toResultType(ofType);
            }
            return utils_1.gqlScalarToTS(name, this.options.typePrefix);
        }
        return 'any';
    };
    TSResolverGenerator.prototype.generateObjectResolver = function (objectType) {
        var _this = this;
        var typeResolverName = "" + this.options.typePrefix + objectType.name + "TypeResolver";
        var typeResolverBody = [];
        var fieldResolversTypeDefs = [];
        objectType.fields.forEach(function (field) {
            // generate args type
            var argsType = '{}';
            var uppercaseFisrtFieldName = utils_1.toUppercaseFirst(field.name);
            if (field.args.length > 0) {
                argsType = objectType.name + "To" + uppercaseFisrtFieldName + "Args";
                var argsBody_1 = [];
                field.args.forEach(function (arg) {
                    var argRefField = utils_1.getFieldRef(arg);
                    var argRefName = argRefField.refName;
                    if (argRefField.refKind === 'SCALAR') {
                        argRefName = utils_1.gqlScalarToTS(argRefName, _this.options.typePrefix);
                    }
                    else if (!utils_1.isBuiltinType({ name: argRefName, kind: argRefField.refKind })) {
                        argRefName = _this.options.typePrefix + argRefName;
                    }
                    var argFieldNameAndType = utils_1.createFieldRef(arg.name, argRefName, argRefField.fieldModifier);
                    argsBody_1.push(argFieldNameAndType);
                });
                fieldResolversTypeDefs.push.apply(fieldResolversTypeDefs, [
                    "export interface " + argsType + " {"
                ].concat(argsBody_1, [
                    '}'
                ]));
            }
            // generate field type
            var fieldResolverName = objectType.name + "To" + uppercaseFisrtFieldName + "Resolver";
            // generate result type
            var resultType = _this.toResultType(field.type);
            resultType = resultType + "|Promise<" + resultType + ">";
            fieldResolversTypeDefs.push.apply(fieldResolversTypeDefs, [
                "export interface " + fieldResolverName + "<TParent = any, TResult = " + resultType + "> {",
                // TODO: some strategy to support parent type and return type
                "(parent: TParent, args: " + argsType + ", context: " + _this.contextType + ", info: GraphQLResolveInfo): TResult;",
                '}',
                ''
            ]);
            typeResolverBody.push.apply(typeResolverBody, [
                field.name + "?: " + fieldResolverName + "<TParent>;"
            ]);
        });
        (_a = this.resolverInterfaces).push.apply(_a, [
            "export interface " + typeResolverName + "<TParent = any> {"
        ].concat(typeResolverBody, [
            '}',
            ''
        ], fieldResolversTypeDefs));
        // add the type resolver to resolver object
        (_b = this.resolverObject).push.apply(_b, [
            objectType.name + "?: " + typeResolverName + ";"
        ]);
        var _a, _b;
    };
    return TSResolverGenerator;
}());
exports.TSResolverGenerator = TSResolverGenerator;
//# sourceMappingURL=typescriptResolverGenerator.js.map